# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ImportExport::Mgmt::V2016_11_01
  module Models
    #
    # Specifies the job properties
    #
    class JobDetails

      include MsRestAzure

      # @return [String] The resource identifier of the storage account where
      # data will be imported to or exported from.
      attr_accessor :storage_account_id

      # @return [String] The type of job
      attr_accessor :job_type

      # @return [ReturnAddress] Specifies the return address information for
      # the job.
      attr_accessor :return_address

      # @return [ReturnShipping] Specifies the return carrier and customer's
      # account with the carrier.
      attr_accessor :return_shipping

      # @return [ShippingInformation] Contains information about the Microsoft
      # datacenter to which the drives should be shipped.
      attr_accessor :shipping_information

      # @return [PackageInfomation] Contains information about the package
      # being shipped by the customer to the Microsoft data center.
      attr_accessor :delivery_package

      # @return [PackageInfomation] Contains information about the package
      # being shipped from the Microsoft data center to the customer to return
      # the drives. The format is the same as the deliveryPackage property
      # above. This property is not included if the drives have not yet been
      # returned.
      attr_accessor :return_package

      # @return [String] The virtual blob directory to which the copy logs and
      # backups of drive manifest files (if enabled) will be stored.
      attr_accessor :diagnostics_path

      # @return [String] Default value is Error. Indicates whether error
      # logging or verbose logging will be enabled.
      attr_accessor :log_level

      # @return [Boolean] Default value is false. Indicates whether the
      # manifest files on the drives should be copied to block blobs.
      attr_accessor :backup_drive_manifest

      # @return [String] Current state of the job.
      attr_accessor :state

      # @return [Boolean] Indicates whether a request has been submitted to
      # cancel the job.
      attr_accessor :cancel_requested

      # @return [Integer] Overall percentage completed for the job.
      attr_accessor :percent_complete

      # @return [String] A blob path that points to a block blob containing a
      # list of blob names that were not exported due to insufficient drive
      # space. If all blobs were exported successfully, then this element is
      # not included in the response.
      attr_accessor :incomplete_blob_list_uri

      # @return [Array<DriveStatus>] List of up to ten drives that comprise the
      # job. The drive list is a required element for an import job; it is not
      # specified for export jobs.
      attr_accessor :drive_list

      # @return [Export] A property containing information about the blobs to
      # be exported for an export job. This property is included for export
      # jobs only.
      attr_accessor :export

      # @return [String] Specifies the provisioning state of the job.
      attr_accessor :provisioning_state


      #
      # Mapper for JobDetails class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'JobDetails',
          type: {
            name: 'Composite',
            class_name: 'JobDetails',
            model_properties: {
              storage_account_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'storageAccountId',
                type: {
                  name: 'String'
                }
              },
              job_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'jobType',
                type: {
                  name: 'String'
                }
              },
              return_address: {
                client_side_validation: true,
                required: false,
                serialized_name: 'returnAddress',
                type: {
                  name: 'Composite',
                  class_name: 'ReturnAddress'
                }
              },
              return_shipping: {
                client_side_validation: true,
                required: false,
                serialized_name: 'returnShipping',
                type: {
                  name: 'Composite',
                  class_name: 'ReturnShipping'
                }
              },
              shipping_information: {
                client_side_validation: true,
                required: false,
                serialized_name: 'shippingInformation',
                type: {
                  name: 'Composite',
                  class_name: 'ShippingInformation'
                }
              },
              delivery_package: {
                client_side_validation: true,
                required: false,
                serialized_name: 'deliveryPackage',
                type: {
                  name: 'Composite',
                  class_name: 'PackageInfomation'
                }
              },
              return_package: {
                client_side_validation: true,
                required: false,
                serialized_name: 'returnPackage',
                type: {
                  name: 'Composite',
                  class_name: 'PackageInfomation'
                }
              },
              diagnostics_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'diagnosticsPath',
                type: {
                  name: 'String'
                }
              },
              log_level: {
                client_side_validation: true,
                required: false,
                serialized_name: 'logLevel',
                type: {
                  name: 'String'
                }
              },
              backup_drive_manifest: {
                client_side_validation: true,
                required: false,
                serialized_name: 'backupDriveManifest',
                type: {
                  name: 'Boolean'
                }
              },
              state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'state',
                type: {
                  name: 'String'
                }
              },
              cancel_requested: {
                client_side_validation: true,
                required: false,
                serialized_name: 'cancelRequested',
                type: {
                  name: 'Boolean'
                }
              },
              percent_complete: {
                client_side_validation: true,
                required: false,
                serialized_name: 'percentComplete',
                type: {
                  name: 'Number'
                }
              },
              incomplete_blob_list_uri: {
                client_side_validation: true,
                required: false,
                serialized_name: 'incompleteBlobListUri',
                type: {
                  name: 'String'
                }
              },
              drive_list: {
                client_side_validation: true,
                required: false,
                serialized_name: 'driveList',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DriveStatusElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'DriveStatus'
                      }
                  }
                }
              },
              export: {
                client_side_validation: true,
                required: false,
                serialized_name: 'export',
                type: {
                  name: 'Composite',
                  class_name: 'Export'
                }
              },
              provisioning_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'provisioningState',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
