# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ImportExport::Mgmt::V2016_11_01
  module Models
    #
    # Specifies the return address information for the job.
    #
    class ReturnAddress

      include MsRestAzure

      # @return [String] The name of the recipient who will receive the hard
      # drives when they are returned.
      attr_accessor :recipient_name

      # @return [String] The first line of the street address to use when
      # returning the drives.
      attr_accessor :street_address1

      # @return [String] The second line of the street address to use when
      # returning the drives.
      attr_accessor :street_address2

      # @return [String] The city name to use when returning the drives.
      attr_accessor :city

      # @return [String] The state or province to use when returning the
      # drives.
      attr_accessor :state_or_province

      # @return [String] The postal code to use when returning the drives.
      attr_accessor :postal_code

      # @return [String] The country or region to use when returning the
      # drives.
      attr_accessor :country_or_region

      # @return [String] Phone number of the recipient of the returned drives.
      attr_accessor :phone

      # @return [String] Email address of the recipient of the returned drives.
      attr_accessor :email


      #
      # Mapper for ReturnAddress class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'ReturnAddress',
          type: {
            name: 'Composite',
            class_name: 'ReturnAddress',
            model_properties: {
              recipient_name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'recipientName',
                type: {
                  name: 'String'
                }
              },
              street_address1: {
                client_side_validation: true,
                required: true,
                serialized_name: 'streetAddress1',
                type: {
                  name: 'String'
                }
              },
              street_address2: {
                client_side_validation: true,
                required: false,
                serialized_name: 'streetAddress2',
                type: {
                  name: 'String'
                }
              },
              city: {
                client_side_validation: true,
                required: true,
                serialized_name: 'city',
                type: {
                  name: 'String'
                }
              },
              state_or_province: {
                client_side_validation: true,
                required: false,
                serialized_name: 'stateOrProvince',
                type: {
                  name: 'String'
                }
              },
              postal_code: {
                client_side_validation: true,
                required: true,
                serialized_name: 'postalCode',
                type: {
                  name: 'String'
                }
              },
              country_or_region: {
                client_side_validation: true,
                required: true,
                serialized_name: 'countryOrRegion',
                type: {
                  name: 'String'
                }
              },
              phone: {
                client_side_validation: true,
                required: true,
                serialized_name: 'phone',
                type: {
                  name: 'String'
                }
              },
              email: {
                client_side_validation: true,
                required: true,
                serialized_name: 'email',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
